var landing = implement("smp:external/superhero_landing");

function init(hero) {
    hero.setName("The Entity");
    hero.setTier(9);
    
    hero.setHelmet("Head");
    hero.setChestplate("Chestpiece");
    hero.setLeggings("Leggings");
    hero.setBoots("Boots");
    
    hero.addPowers("smp:code");
    hero.addAttribute("PUNCH_DAMAGE", 10, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.7, 0);
    hero.addAttribute("FALL_RESISTANCE", 1, 1);
    hero.addAttribute("SPRINT_SPEED", 0.3, 1);
    hero.addAttribute("WEAPON_DAMAGE", -0.95, 1);

    hero.addKeyBind("CHARGED_BEAM", "Wrath of the Code", 1);
    hero.addKeyBind("ENERGY_PROJECTION", "Code Energy", 2);
    hero.addKeyBind("TELEPORT", "Teleport", 3);
    hero.addKeyBind("TELEKINESIS", "Telekinesis", 4);
    hero.addKeyBind("BLADE", "Axe of Wrathius", 5);

    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.addAttributeProfile("BLADE", bladeProfile);
    hero.setAttributeProfile(getProfile);
    hero.setDamageProfile(getProfile);
    hero.addDamageProfile("BLADE", {"types": {"SHARP": 1.0}});




    hero.setTickHandler((entity, manager) => {
        landing.tick(entity, manager);
    });
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "CHARGED_BEAM":
        return !entity.getData("fiskheroes:telekinesis") && !(entity.isSprinting() && entity.getData("fiskheroes:flying"));
    case "ENERGY_PROJECTION":
        return !entity.getData("fiskheroes:telekinesis");
    case "TELEKINESIS":
        return !(entity.isSprinting() && entity.getData("fiskheroes:flying"));
    default:
        return true;
    }
}

function bladeProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 19.0, 0);
}

function getProfile(entity) {
    return entity.getData("fiskheroes:blade") ? "BLADE" : null;
}

function hasProperty(entity, property) {
    return property == "BREATHE_SPACE";
}
