function init(hero) {
    hero.setName("Phantom Knight");
    hero.setTier(6);

    hero.setHelmet("Helmet");
    hero.setChestplate("Chestplate");
    hero.setLeggings("Leggings");
    hero.setBoots("Boots");

    hero.addPowers("smp:darkness_manipulation");
    hero.addAttribute("PUNCH_DAMAGE", 5.5, 0);
    hero.addAttribute("WEAPON_DAMAGE", 2.0, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.5, 0);
    hero.addAttribute("FALL_RESISTANCE", 6.0, 0);
    hero.addAttribute("SPRINT_SPEED", 0.2, 1);

    hero.addKeyBind("CHARGED_BEAM", "Dark Pulse", 1);
    hero.addKeyBind("SHADOWFORM", "key.shadowForm", 2);
    hero.addKeyBind("SHADOWDOME", "key.shadowDome", 3);
    hero.addKeyBind("TELEKINESIS", "key.telekinesis", 4);
    hero.addKeyBind("BLADE", "Toggle Shadow Blade", 5);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);

    hero.addAttributeProfile("BLADE", bladeProfile);
    hero.setAttributeProfile(getProfile);
    hero.setDamageProfile(getProfile);
    hero.addDamageProfile("BLADE", {"types": {"SHARP": 1.0}});
}

function isModifierEnabled(entity, modifier) {
    switch (modifier.name()) {
    case "fiskheroes:flight":
        return entity.getData("fiskheroes:shadowform");
    case "fiskheroes:controlled_flight":
        return !entity.getData("fiskheroes:shadowform")
    default:
        return true;
    }
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
        case "CHARGED_BEAM":
            return !entity.getData("fiskheroes:telekinesis") && !entity.getData("fiskheroes:shadowform");
        case "SHADOWDOME":
            return !entity.getData("fiskheroes:beam_charging") && !entity.getData("fiskheroes:shadowform") && !entity.getData("fiskheroes:telekinesis");
        case "TELEKINESIS":
            return !entity.getData("fiskheroes:shadowform") && !entity.getData("fiskheroes:beam_charging");
        case "BLADE":
            return !entity.getData("fiskheroes:shadowform") && !entity.getData("fiskheroes:beam_charging");
        default:
            return true;
        }
}

function bladeProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 9.0, 0);
}

function getProfile(entity) {
    return entity.getData("fiskheroes:blade") ? "BLADE" : null;
}
