var landing = implement("smp:external/superhero_landing");
var super_boost = implement("fiskheroes:external/super_boost");

function init(hero) {
    hero.setName("Super Potato Boi");
    hero.setTier(7);
    
    hero.setHelmet("Helmet");
    hero.setChestplate("Chestplate");
    hero.setLeggings("Leggings");
    hero.setBoots("Boots");
    
    hero.addPowers("smp:potato_squad_experiment");
    hero.addAttribute("MAX_HEALTH", 10, 0);
    hero.addAttribute("PUNCH_DAMAGE", 10, 0);
    hero.addAttribute("JUMP_HEIGHT", 1, 0);
    hero.addAttribute("FALL_RESISTANCE", 1, 1);
    hero.addAttribute("SPRINT_SPEED", 0.4, 1);
    hero.addAttribute("BASE_SPEED_LEVELS", 2.0, 0);

    hero.addKeyBind("SONIC_WAVES", "Potato Scream", 1);
    hero.addKeyBind("HEAT_VISION", "Potato Laser Eyes", 2);
    hero.addKeyBind("SUPER_SPEED", "key.superSpeed", 3);
    super_boost.addKeyBind(hero, "key.boost", 1);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setHasProperty(hasProperty);

    hero.addAttributeProfile("ONE", oneProfile);
    hero.addAttributeProfile("TWO", twoProfile);
    hero.addAttributeProfile("THREE", threeProfile);
    hero.addAttributeProfile("FOUR", fourProfile);
    hero.setAttributeProfile(getProfile);

    hero.setTickHandler((entity, manager) => {
        var y = entity.posY() >= 320;
        var t = entity.getData("smp:dyn/cook_timer");
        manager.incrementData(entity, "smp:dyn/cook_timer", 1200, y && !entity.getData("fiskheroes:heat_vision"), entity.getData("fiskheroes:heat_vision") || !y && t > 0.5);
        manager.incrementData(entity, "fiskheroes:dyn/flight_super_boost_timer", 16, 6, entity.getData("fiskheroes:dyn/flight_super_boost") > 0)

        landing.tick(entity, manager);
        super_boost.tick(entity, manager);
    });
}

function hasProperty(entity, property) {
    return property == "BREATHE_SPACE";
}

function isModifierEnabled(entity, modifier) {
    if (modifier.name() == "fiskheroes:heat_vision") {
        var cook = entity.getData("smp:dyn/cook_timer");
        return (modifier.id() == "cooked") == (cook >= 0.25);
    }
    else if (modifier.name() == "fiskheroes:super_speed") {
        return !entity.getData("fiskheroes:flying");
    }
    return super_boost.isModifierEnabled(entity, modifier);
}

function isKeyBindEnabled(entity, keyBind) {
    if (keyBind == "SONIC_WAVES") {
        return !(entity.getData("fiskheroes:flying") && entity.isSprinting());
    }
    else if (keyBind == "SUPER_SPEED") {
        return !entity.getData("fiskheroes:flying");
    }
    return super_boost.isKeyBindEnabled(entity, keyBind);
}

function oneProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("MAX_HEALTH", 5.0, 0);
}

function twoProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("MAX_HEALTH", 0.0, 0);
}

function threeProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("MAX_HEALTH", -5.0, 0);
}

function fourProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("MAX_HEALTH", -10.0, 0);
}

function getProfile(entity) {
    var t = entity.getData("smp:dyn/cook_timer");
    return t == 1 ? "FOUR" : t >= 0.75 ? "THREE" : t >= 0.5 ? "TWO" : t >= 0.25 ? "ONE" : null;
}