var speedster_base = implement("fiskheroes:external/speedster_base");

function init(hero) {
    hero.setName("Revertax");
    hero.setTier(6);

    hero.setHelmet("item.superhero_armor.piece.helmet");
    hero.setChestplate("item.superhero_armor.piece.chestplate");
    hero.setLeggings("item.superhero_armor.piece.leggings");
    hero.setBoots("item.superhero_armor.piece.boots");

    hero.addPowers("smp:redacted");
    hero.addAttribute("PUNCH_DAMAGE", 7.0, 0);
    hero.addAttribute("SPRINT_SPEED", 0.15, 1);
    hero.addAttribute("JUMP_HEIGHT", 0.5, 0);
    hero.addAttribute("FALL_RESISTANCE", 1.0, 1);
    hero.addAttribute("BASE_SPEED_LEVELS", 5.0, 0);

    hero.addKeyBind("ENERGY_PROJECTION", "Speed Knockback", -2);
    hero.addKeyBind("SUPER_SPEED", "key.superSpeed", 1);
    hero.addKeyBind("CHARGED_BEAM", "Lightning Blast", 2);
    hero.addKeyBind("SONIC_WAVES", "Tornado Arms", 3);
    hero.addKeyBind("SLOW_MOTION", "key.slowMotion", 4);

    hero.setModifierEnabled(isModifierEnabled);
    hero.addAttributeProfile("SUPER_PUNCH", superPunchProfile);
    hero.addAttributeProfile("BEAM", beamProfile);
    hero.setAttributeProfile(getProfile);

    /*hero.setHasProperty((entity, property) => property == "MASK_TOGGLE");

    hero.addSoundEvent("MASK_OPEN", ["fiskheroes:reverse_flash_vibration_on", "fiskheroes:reverse_flash_vibration_loop"]);*/

    hero.setTickHandler((entity, manager) => {
        manager.incrementData(entity, "smp:dyn/super_punch_timer", 80, 40, entity.getData("fiskheroes:speed_sprinting") && entity.getData("fiskheroes:speed") > 2, entity.getData("smp:dyn/super_punch_timer") < 1);

        if (entity.getData("smp:dyn/super_punch_timer") == 1 && entity.isPunching() || entity.isSneaking() || !entity.getData("smp:dyn/speedster")) {
            manager.setInterpolatedData(entity, "smp:dyn/super_punch_timer", 0);
        }

        speedster_base.tick(entity, manager);

        manager.incrementData(entity, "smp:dyn/tornado_arms_timer", 4, entity.getData("fiskheroes:sonic_waves"));

        manager.setData(entity, "fiskheroes:energy_projection", entity.getData("fiskheroes:speed_sprinting") && entity.getData("fiskheroes:speed") > 1);
    });
}

function isModifierEnabled(entity, modifier) {
    if (modifier.name() != "fiskheroes:super_speed" && modifier.name() != "fiskheroes:sonic_waves" && modifier.name() != "fiskheroes:slow_motion" && modifier.name() != "fiskheroes:arrow_catching" && modifier.name() != "fiskheroes:charged_beam" && modifier.name() != "fiskheroes:energy_projection") {
        return false;
    }
    return true;
}

function superPunchProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 11.0, 0);
    profile.addAttribute("KNOCKBACK", 10.0, 0);
}

function beamProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("BASE_SPEED", -1.0, 1);
    profile.addAttribute("SPRINT_SPEED", -1.0, 1);
}

function getProfile(entity) {
    return entity.getData("smp:dyn/speedster") ? entity.getData("smp:dyn/super_punch_timer") == 1 ? "SUPER_PUNCH" : entity.getData("fiskheroes:beam_shooting") ? "BEAM" : "SPEEDSTER" : null;
}
