extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:null",
    "layer2": "smp:null",
    "head": "smp:red_glare_head",
    "body": "smp:red_glare_body",
    "arm": "smp:red_glare_arm",
    "segment": "smp:red_glare_tentacle",
    "claw": "fiskheroes:doctor_octopus_claw"
});

var utils = implement("fiskheroes:external/utils");

function init(renderer) {
    parent.init(renderer);
}

function initEffects(renderer) {
    var tentacle_arm = utils.createModel(renderer, "smp:red_glare_tentacle", "segment");
    var ock_claw = utils.createModel(renderer, "fiskheroes:ock_claw", "claw");
    ock_claw.bindAnimation("fiskheroes:ock_claw").setData((entity, data) => {
        var t = entity.as("TENTACLE");
        data.load(0, 1 - Math.min(t.getCaster().getInterpolatedData("fiskheroes:tentacle_extend_timer") * 2, 1));
        data.load(1, t.getIndex());
        data.load(2, t.getGrabTimer());
        data.load(3, t.getStrikeTimer());
    });

    var tentacles = renderer.bindProperty("fiskheroes:tentacles").setTentacles([
        { "offset": [2.0, -4.5, -2.0], "direction": [13.0, 10.0, -10.0] },
        { "offset": [-2.0, -4.5, -2.0], "direction": [-13.0, 10.0, -10.0] },
        { "offset": [2.0, -7.5, -2.0], "direction": [13.0, -10.0, -10.0] },
        { "offset": [-2.0, -7.5, -2.0], "direction": [-13.0, -10.0, -10.0] }
    ]);
    tentacles.anchor.set("body");
    tentacles.setSegmentModel(tentacle_arm);
    tentacles.setHeadModel(ock_claw);
    tentacles.segmentLength = 1.8;
    tentacles.segments = 16;

    utils.bindBeam(renderer, "fiskheroes:heat_vision", "smp:laser_vision", "head", 0xBF0018, [
        { "firstPerson": [0.0, 0.0, 2.0], "offset": [0.0, -5.0, -3.0], "size": [3.0, 3.0] }
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_heat_vision"));

    renderer.bindProperty("fiskheroes:opacity").setOpacity((entity, renderLayer) => {
        return 0.99999;
    });

    var head_model = renderer.createResource("MODEL", "smp:red_glare_head");
    head_model.texture.set("head");
    head = renderer.createEffect("fiskheroes:model").setModel(head_model);
    head.anchor.set("head");
    head.setOffset(0, -22, 0);

    var body_model = renderer.createResource("MODEL", "smp:red_glare_body");
    body_model.texture.set("body");
    body = renderer.createEffect("fiskheroes:model").setModel(body_model);
    body.anchor.set("body");
    body.setOffset(0, 2.9, 0);

    var arm_model = renderer.createResource("MODEL", "smp:red_glare_arm");
    arm_model.texture.set("arm");

    right_arm = renderer.createEffect("fiskheroes:model").setModel(arm_model);
    right_arm.anchor.set("rightArm");
    right_arm.setOffset(1, -10, 0);

    left_arm = renderer.createEffect("fiskheroes:model").setModel(arm_model);
    left_arm.anchor.set("leftArm");
    left_arm.setOffset(-1, -10, 0);
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);

    addAnimation(renderer, "red_glare.DEFAULT", "smp:red_glare").setData((entity, data) => {
        data.load(1);
    });
}

function render(entity, renderLayer, isFirstPersonArm) {
    head.render();
    head.setScale(1/1.125);
    body.render();
    body.setScale(1/1.125);
    right_arm.render();
    right_arm.setScale(1/1.125);
    left_arm.render();
    left_arm.setScale(1/1.125);
}
