extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:the_headless_codeman_layer1",
    "layer2": "smp:the_headless_codeman_layer2",
    "cape": "smp:the_headless_codeman_cape"
});
var utils = implement("fiskheroes:external/utils");
var capes = implement("fiskheroes:external/capes");

var cape;

function initEffects(renderer) {
    var beam = renderer.createResource("BEAM_RENDERER", "fiskheroes:mysterio_beam");
    utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:war_cry", "head", 0xF03535, [
        { "firstPerson": [0, 0, 0], "offset": [0, 0.25, 1.0], "size": [2.0, 2.0] }
    ]);

    utils.bindBeam(renderer, "fiskheroes:energy_projection", beam, "head", 0xF03535, [
        { "firstPerson": [2.2, 0.0, 2.0], "offset": [2.2, -5.25, -4.0], "size": [2.5, 0.5] },
        { "firstPerson": [-2.2, 0.0, 2.0], "offset": [-2.2, -5.25, -4.0], "size": [2.5, 0.5] }
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_energy_projection"));

    var physics = renderer.createResource("CAPE_PHYSICS", null);
    physics.maxFlare = 0.4;
    cape = capes.createDefault(renderer, 24, "fiskheroes:cape_default.mesh.json", physics);
    cape.effect.texture.set("cape");
    cape.effect.width = 12;
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    utils.addFlightAnimationWithLanding(renderer, "iron_man.FLIGHT", "fiskheroes:flight/iron_man.anim.json");
    utils.addHoverAnimation(renderer, "mmcw.HOVER", "fiskheroes:flight/idle/neutral");
    utils.addAnimationEvent(renderer, "FLIGHT_DIVE", "fiskheroes:iron_man_dive");

    renderer.removeCustomAnimation("basic.ENERGY_PROJ");

    addAnimationWithData(renderer, "iron_man.LAND", "fiskheroes:superhero_landing", "fiskheroes:dyn/superhero_landing_timer")
        .priority = -8;

    addAnimationWithData(renderer, "iron_man.ROLL", "fiskheroes:flight/barrel_roll", "fiskheroes:barrel_roll_timer")
        .priority = 10;
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (!isFirstPersonArm && renderLayer == "CHESTPLATE") {
        cape.render(entity);
    }
}